// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'ngCordova'])

        .run(function ($ionicPlatform) {
            $ionicPlatform.ready(function () {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                    cordova.plugins.Keyboard.disableScroll(true);

                }
                if (window.StatusBar) {
                    // org.apache.cordova.statusbar required
                    StatusBar.styleDefault();
                }
            });
        })

        .directive('ngEnter', function () {
            return function (scope, element, attrs) {
                element.bind("keydown keypress", function (event) {
                    if (event.which === 13) {
                        scope.$apply(function () {
                            scope.$eval(attrs.ngEnter);
                        });

                        event.preventDefault();
                    }
                });
            };
        })

        .config(function ($stateProvider, $urlRouterProvider) {
            $stateProvider

                    .state('app', {
                        url: '/app',
                        abstract: true,
                        templateUrl: 'templates/menu.html',
                        controller: 'AppCtrl'
                    })
                    /**
                     * Not required as of now, preserving it for the future
                     .state('app.search', {
                     url: '/search',
                     views: {
                     'menuContent': {
                     templateUrl: 'templates/search.html'
                     }
                     }
                     })
                     
                     .state('app.browse', {
                     url: '/browse',
                     views: {
                     'menuContent': {
                     templateUrl: 'templates/browse.html'
                     }
                     }
                     })
                     */
                    .state('app.stores', {
                        url: '/stores',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/stores.html',
                                controller: 'StoresCtrl'
                            }
                        }
                    })
                    .state('app.offers', {
                        url: '/offers/:searchString',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/offers.html',
                                controller: 'OffersCtrl'
                            }
                        }
                    })
                    .state('app.store', {
                        url: '/store/:storeId',
                        views: {
                            'menuContent': {
                                templateUrl: 'templates/store.html',
                                controller: 'StoreCtrl'
                            }
                        }
                    });
            // if none of the above states are matched, use this as the fallback
            $urlRouterProvider.otherwise('/app/stores');
        });