angular.module('starter.controllers', [])

        .controller('AppCtrl', function ($scope, $ionicModal, $timeout, $cordovaOauth, $http, $ionicLoading, $state) {


            if (window.localStorage.getItem('shopper') === null) {
                console.log("No user logged/nothing in the local storage....");
                $scope.shopper = {};
                $scope.shopperDetails = false;
                $scope.goToMerchant = false;
                $scope.goToOffer = false;
            } else {
                $scope.shopperDetails = true;
                $scope.goToMerchant = true;
                $scope.goToOffer = true;
                $scope.shopper = JSON.parse(window.localStorage['shopper'] || '{}');
                console.log("Logged in user in local storage: " + JSON.stringify($scope.shopper));
            }

            //search bar related
            $scope.searchBar = false;
            $scope.showHideSearchBar = function () {
                if ($scope.searchBar === true) {
                    $scope.searchBar = false;
                } else {
                    $scope.searchBar = true;
                }
            };
            // on press of enter key on the search box
            $scope.searchEnter = function () {
                $state.go('app.offers', {"searchString": $scope.searchString});
                //hide the search bar & clear content
                $scope.searchBar = false;
                //$scope.searchText = ' ';
            };
            /**
             * Bootrap auto-complete related, not using as of now
             // Any function returning a promise object can be used to load values asynchronously
             $scope.getStoresNOffersLikeName = function (searchString) {
             if (searchString.length > 2) {//query further only if more than 3 characters are entered
             $scope.matchedStoresNOffers = [];//list of matching products
             return $http.get('http://cashable.in/AppsGateway?request-type=get-merchant-offers-like&search-string=' + searchString + '&max-results=30',
             {}).then(function (response) {
             return response.data.offerCampaigns.map(function (item) {
             $scope.matchedStoresNOffers.push(item.merchantName);// + ": " + item.offerCampaignDetails);
             return item.merchantName;// + ": " + item.offerCampaignDetails;//item.merchantName;
             });
             });
             }
             };
             
             // on press of enter key on the search box
             $scope.onEnterSearch = function (keyEvent) {
             if (keyEvent.which === 13) {
             $scope.search();
             }
             };
             // on search
             $scope.search = function () {
             $state.go('app.offers', {"searchString": $scope.searchString});
             //hide the search bar & clear content
             $scope.searchBar = false;
             //$scope.searchText = ' ';
             };
             */
            // Open the login modal
            $scope.login = function () {
                $scope.modal.show();
            };

            // Create the login modal that we will use later
            $ionicModal.fromTemplateUrl('templates/login.html', {
                scope: $scope
            }).then(function (modal) {
                $scope.modal = modal;
            });

            // Triggered in the login modal to close it
            $scope.closeLogin = function () {
                $scope.modal.hide();
            };

            $scope.googleLogin = function () {
                $ionicLoading.show();
//                $cordovaOauth.google("581628036880-16cff2b7mo79f34sb209637lt3md8lln.apps.googleusercontent.com", 
//                                            ["https://www.googleapis.com/auth/urlshortener", 
//                                                "https://www.googleapis.com/auth/userinfo.email", 
//                                                "https://www.googleapis.com/auth/userinfo.profile"]).then(function(authResponse) {
//                $cordovaOauth.google("581628036880-16cff2b7mo79f34sb209637lt3md8lln.apps.googleusercontent.com", 
//                                                ["https://www.googleapis.com/auth/plus.me"]).then(function (authResponse) {                 
//                $cordovaOauth.google("581628036880-16cff2b7mo79f34sb209637lt3md8lln.apps.googleusercontent.com", 
//                                                ["https://www.googleapis.com/auth/plus.login"]).then(function (authResponse) {               

                // 1. authenticate user with google+
                $cordovaOauth.google("581628036880-16cff2b7mo79f34sb209637lt3md8lln.apps.googleusercontent.com",
                        ["https://www.googleapis.com/auth/userinfo.email",
                            "https://www.googleapis.com/auth/userinfo.profile"]).then(function (authResponse) {
                    console.log("SUCCESS: " + JSON.stringify(authResponse));

                    // 2. get authenticated users profile details
                    $http.get('https://www.googleapis.com/oauth2/v3/userinfo?alt=json&access_token=' + authResponse.access_token).
                            success(function (profileData, status, headers, config) {
                                console.log("SUCCESS: GET https://www.googleapis.com/oauth2/v3/userinfo?alt=json&access_token=" + authResponse.access_token);
                                //$scope.shopper = profileData;
                                console.log("Profile details: " + JSON.stringify(profileData));
                                console.log("Email: " + profileData.email
                                        + ", Name: " + profileData.name
                                        + ", Gender: " + profileData.gender
                                        + ", Profile photo: " + profileData.picture + "?sz=150");
                                $scope.shopper.email = profileData.email;
                                $scope.shopper.name = profileData.name;
                                $scope.shopper.gender = profileData.gender;
                                $scope.shopper.picture = profileData.picture + "?sz=200";

                                // 3. send shopper details to Cashable server, this will get the shopper details if already exists else create shopper and get details
                                $http.get('http://cashable.in/AppsGateway?request-type=get-shopper-details&email=' + $scope.shopper.email
                                        + '&name=' + $scope.shopper.name + '&gender=' + $scope.shopper.gender
                                        + '&picture=' + $scope.shopper.picture + '&shopper-auth-provider=googleplus&last-login-ip=127.0.0.1').
                                        success(function (data, status, headers, config) {
                                            console.log("SUCCESS: GET http://cashable.in/AppsGateway?request-type=get-shopper-details... " + JSON.stringify(data));
                                            $scope.shopper = data;
                                            console.log("Storing shopper into the local storage");
                                            window.localStorage['shopper'] = JSON.stringify($scope.shopper);
                                            $scope.shopperDetails = true;
                                            $scope.goToMerchant = true;
                                            $scope.goToOffer = true;
                                        }).
                                        error(function (data, status, headers, config) {
                                            console.log("Error getting/creating shopper details: " + JSON.stringify(data));
                                            alert("Error getting/creating shopper, please try after sometime!");
                                        });

                                $ionicLoading.hide();
                            }).
                            error(function (profileDataError, status, headers, config) {
                                $ionicLoading.hide();
                                console.error("Error featching profile details: " + JSON.stringify(profileDataError));
                                alert("Unable to fetch profile details from Google+, please try after sometime!");
                            });
                }, function (error) {
                    $ionicLoading.hide();
                    console.error("Error authenticating with Google+: " + error);
                    alert("Error authenticating with Google+, please try after sometime!");
                });
            };

            $scope.facebookLogin = function () {
                $ionicLoading.show();
                // 1. authenticate with Facebook
                $cordovaOauth.facebook("538687026273343", ["email"]).then(function (authResponse) {
                    console.log("SUCCESS-authenticating with Facebook: " + JSON.stringify(authResponse));

                    // 2. get authenticated users profile details
                    $http.get('https://graph.facebook.com/me?access_token=' + authResponse.access_token).
                            success(function (profileData, status, headers, config) {
                                console.log("SUCCESS: GET https://graph.facebook.com/me?access_token=" + authResponse.access_token);
                                //$scope.shopper = profileData;
                                console.log("Profile details: " + JSON.stringify(profileData));
                                console.log("Email: " + profileData.email
                                        + ", Name: " + profileData.name
                                        + ", Gender: " + profileData.gender
                                        + ", Profile photo: https://graph.facebook.com/" + profileData.id + "/picture?type=large");
                                $scope.shopper.email = profileData.email;
                                $scope.shopper.name = profileData.name;
                                $scope.shopper.gender = profileData.gender;
                                $scope.shopper.picture = "https://graph.facebook.com/" + profileData.id + "/picture?type=large";

                                // 3. send shopper details to Cashable server, this will get the shopper details if already exists else create shopper and get details
                                $http.get('http://cashable.in/AppsGateway?request-type=get-shopper-details&email=' + $scope.shopper.email
                                        + '&name=' + $scope.shopper.name + '&gender=' + $scope.shopper.gender
                                        + '&picture=' + $scope.shopper.picture + '&shopper-auth-provider=facebook&last-login-ip=127.0.0.1').
                                        success(function (data, status, headers, config) {
                                            console.log("SUCCESS: GET http://cashable.in/AppsGateway?request-type=get-shopper-details... " + JSON.stringify(data));
                                            $scope.shopper = data;
                                            console.log("Storing shopper into the local storage");
                                            window.localStorage['shopper'] = JSON.stringify($scope.shopper);
                                            $scope.shopperDetails = true;
                                            $scope.goToMerchant = true;
                                            $scope.goToOffer = true;
                                        }).
                                        error(function (data, status, headers, config) {
                                            console.log("Error getting/creating shopper details: " + JSON.stringify(data));
                                            alert("Error getting/creating shopper, please try after sometime!");
                                        });

                                $ionicLoading.hide();
                            }).
                            error(function (profileDataError, status, headers, config) {
                                $ionicLoading.hide();
                                console.error("Error featching profile details: " + JSON.stringify(profileDataError));
                                alert("Unable to fetch profile details from Facebook, please try after sometime!");
                            });
                }, function (authError) {
                    $ionicLoading.hide();
                    console.error("Error authenticating with Facebook: " + authError);
                    alert("Error authenticating with Facebook, please try after sometime!");
                });
            };

            // Triggered in the login modal to close it
            $scope.logout = function () {
                window.localStorage.clear();
                $scope.shopper = {};
                console.log("User logged out: " + JSON.stringify($scope.shopper) + ", exiting app.");
                ionic.Platform.exitApp();
            };

            /**
             * NOT REQUIRED NOW, PRESERVING FOR FUTURE
             // With the new view caching in Ionic, Controllers are only called
             // when they are recreated or on app start, instead of every page change.
             // To listen for when this page is active (for example, to refresh data),
             // listen for the $ionicView.enter event:
             //$scope.$on('$ionicView.enter', function(e) {
             //});
             
             // Form data for the login modal
             $scope.loginData = {};
             
             // Perform the login action when the user submits the login form
             $scope.doLogin = function () {
             console.log('Doing login', $scope.loginData);
             
             // Simulate a login delay. Remove this and replace with your login
             // code if using a login system
             $timeout(function () {
             $scope.closeLogin();
             }, 1000);
             };
             */
        })

        .controller('StoresCtrl', function ($scope, $http, $ionicLoading) {
            $ionicLoading.show();
            $http.get('http://cashable.in/AppsGateway?request-type=get-merchants-by-plan&plan=2&max-results=30').
                    success(function (data, status, headers, config) {
                        console.log("SUCCESS: GET http://cashable.in/AppsGateway?request-type=get-merchants-by-plan&plan=2&max-results=30" + JSON.stringify(data));
                        $scope.merchants = data.merchants;
                        $ionicLoading.hide();
                    }).
                    error(function (data, status, headers, config) {
                        console.log("Error getting stores by plan: " + JSON.stringify(data));
                        $ionicLoading.hide();
                        alert("Error getting stores, please try after sometime!");
                    });
        })

        .controller('StoreCtrl', function ($scope, $stateParams, $http, $ionicLoading, $cordovaClipboard, $ionicPopup) {
            $ionicLoading.show();
            $http.get('http://cashable.in/AppsGateway?request-type=get-merchant-details&merchant-id=' + $stateParams.storeId).
                    success(function (data, status, headers, config) {
                        console.log("SUCCESS: GET http://cashable.in/AppsGateway?request-type=get-merchant-details&merchant-id=" + $stateParams.storeId + JSON.stringify(data));
                        $ionicLoading.hide();
                        $scope.merchant = data;
                    }).
                    error(function (data, status, headers, config) {
                        console.log("Error getting store details: " + JSON.stringify(data));
                        $ionicLoading.hide();
                        alert("Error getting store details, please try after sometime!");
                    });

            // functioh to copy coupon code
            $scope.copyText = function (value) {
                $cordovaClipboard.copy(value).then(function () {
                    console.log("Copied text: " + value);
                }, function () {
                    console.error("There was an error copying");
                });
            };

            $scope.showConfirm = function (titleStr, templateStr, redirectUrl) {
                var confirmPopup = $ionicPopup.confirm({
                    title: titleStr,
                    subTitle: 'Always use mobile site to get the cashback. (SKIP APP DOWNLOAD PAGE AFTER REDIRECTION)',
                    template: templateStr,
                    okText: 'Go to merchant',
                    cancelText: 'Cancel'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        console.log('Take to merchant`s site...');
                        if ($scope.merchant.merchantHasCashbackCampaign) {
                            console.log('Valid cashback campaign available so recording the clickthrough...');

//                            var clickThrough = {};
//                            clickThrough."request-type" = "track-clickthrough";
//                            clickThrough."merchant-id" = $scope.merchant.merchantId;
//                            clickThrough."shopper-id" = $scope.shopper.shopperId;
//                            clickThrough."current-url" = "/app/store/storeId";
//                            clickThrough."clickthrough-url" = redirectUrl;
//                            clickThrough."shopper-device-ip" = "1000.1000.1000.1000";
                            var clickThrough = '{"request-type": "track-clickthrough","merchant-id": ' + $scope.merchant.merchantId
                                    + ',"shopper-id": ' + $scope.shopper.shopperId + ',"current-url": "/app/store","clickthrough-url": "'
                                    + redirectUrl + '","shopper-device-ip": "1000.1000.1000.1000"}';

                            $http.post('http://cashable.in/AppsGateway?request-type=track-clickthrough', JSON.parse(clickThrough)).
                                    then(function (response) {
                                        window.open(response.data.updatedClickthroughUrl, '_system');
                                    }, function (response) {
                                        console.log("Error recording clickthrough: " + JSON.stringify(response));
                                    });
                        } else {
                            console.log('No valid cashback campaign available so no need to record clickthrough...');
                            window.open(redirectUrl, '_system');
                        }
                    } else {
                        console.log('User dont want to go merchant`s site...');
                    }
                });
            };

            $scope.redirectToOffer = function (clickedOffer) {
                console.log("redirectToOffer: " + clickedOffer.offerCampaignClickthroughURL);
                if (clickedOffer.offerCampaignCouponCode) {
                    $scope.copyText(clickedOffer.offerCampaignCouponCode);
                    $scope.showConfirm('COUPON `' + clickedOffer.offerCampaignCouponCode + '` COPIED',
                            'Coupon code `' + clickedOffer.offerCampaignCouponCode
                            + '` copied to your clipboard. Click below to start shopping.', clickedOffer.offerCampaignClickthroughURL);
                } else {
                    $scope.showConfirm('OFFER ACTIVATED',
                            'Click below to start shopping, no coupon code required.', clickedOffer.offerCampaignClickthroughURL);
                }
            };

            $scope.redirectToMerchant = function (merchantUrl) {
//                console.log("redirectToMerchant: " + merchantUrl);
//                window.open(merchantUrl, '_system');
                $scope.showConfirm('OFFER ACTIVATED',
                        'Click below to start shopping, no coupon code required.', merchantUrl);
            };

            /**
             * Function shows the cashback campaigns on the popup
             * @returns {undefined}
             */
            $scope.showCashbackCampaings = function () {

                //create the template with cashback campaigns list
                var cashbackCmpgns = '<div class="list">';
                for (var i = 0; i < $scope.merchant.cashbackCampaigns.length; i++) {
                    cashbackCmpgns = cashbackCmpgns + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'
                            + '<h3 style="font-family: fontawesome !important;">'
                            + $scope.merchant.cashbackCampaigns[i].cashbackCampaignPunchline + '</h3>'
                            + '<p style="font-family: fontawesome !important;">'
                            + $scope.merchant.cashbackCampaigns[i].cashbackCampaignDetails + '</p>'
                            + '</a>';
                }
                cashbackCmpgns += '</div>';

                var cashbackPopup = $ionicPopup.show({
                    template: cashbackCmpgns,
                    title: 'CASHBACK CAMPAIGNS',
                    subTitle: $scope.merchant.merchantName,
                    scope: $scope,
                    buttons: [
                        {text: 'OK'}
                    ]
                });
            };

            $scope.showHowToNTerms = function () {
                //create the template with cashback campaigns list
                var HowToNTerms = '<div class="list">'
                        + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'
                        + '<h2>HOW TO</h2>'
                        + '</a>'                
                        + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'                
                        + '<p>Always use mobile site to get the cashback.</p>'
                        + '</a>'                
                        + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'                      
                        + '<p>Always skip app download page after re-direction.</p>'        
                        + '</a>'
                        + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'
                        + '<h2>TERMS & CONDITIONS</h2>'
                        + '</a>'                
                        + '<a class="item item-text-wrap" style="background-color: #f6f6f6">'                
                        + '<p>Terms and conditions from the merchant are applicable.</p>'
                        + '</a>'                                
                        + '</div>';

                var cashbackPopup = $ionicPopup.show({
                    template: HowToNTerms,
                    title: 'HOW TO & TERMS',
                    subTitle: $scope.merchant.merchantName,
                    scope: $scope,
                    buttons: [
                        {text: 'OK'}
                    ]
                });
            };
        })

        .controller('OffersCtrl', function ($scope, $stateParams, $http, $ionicLoading, $cordovaClipboard, $ionicPopup) {
            $ionicLoading.show();
            $http.get('http://cashable.in/AppsGateway?request-type=get-merchant-offers-like&search-string=' + $stateParams.searchString + '&max-results=30').
                    success(function (data, status, headers, config) {
                        console.log("SUCCESS: GET http://cashable.in/AppsGateway?request-type=get-merchant-offers-like&search-string=" + $stateParams.searchString + "&max-results=30: " + JSON.stringify(data));
                        $scope.offerCampaigns = data.offerCampaigns;
                        $ionicLoading.hide();
                    }).
                    error(function (data, status, headers, config) {
                        console.log("Error getting offers like: " + JSON.stringify(data));
                        $ionicLoading.hide();
                        alert("Error getting offers, please try after sometime!");
                    });

            // functioh to copy coupon code
            $scope.copyText = function (value) {
                $cordovaClipboard.copy(value).then(function () {
                    console.log("Copied text: " + value);
                }, function () {
                    console.error("There was an error copying");
                });
            };

            $scope.showConfirm = function (titleStr, templateStr, clickedOffer) {//redirectUrl) {
                var confirmPopup = $ionicPopup.confirm({
                    title: titleStr,
                    subTitle: 'Always use mobile site to get the cashback. (SKIP APP DOWNLOAD PAGE AFTER REDIRECTION)',
                    template: templateStr,
                    okText: 'Go to merchant',
                    cancelText: 'Cancel'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        console.log('Take to merchant`s site...');
                        if (clickedOffer.merchantHasCashbackCampaign) {
                            console.log('Valid cashback campaign available so recording the clickthrough...');
                            var clickThrough = '{"request-type": "track-clickthrough","merchant-id": ' + clickedOffer.merchantId
                                    + ',"shopper-id": ' + $scope.shopper.shopperId + ',"current-url": "/app/offers","clickthrough-url": "'
                                    + clickedOffer.offerCampaignClickthroughURL + '","shopper-device-ip": "1000.1000.1000.1000"}';
                            $http.post('http://cashable.in/AppsGateway?request-type=track-clickthrough', JSON.parse(clickThrough)).
                                    then(function (response) {
                                        window.open(response.data.updatedClickthroughUrl, '_system');
                                    }, function (response) {
                                        console.log("Error recording clickthrough: " + JSON.stringify(response));
                                    });
                        } else {
                            console.log('No valid cashback campaign available so no need to record clickthrough...');
                            window.open(clickedOffer.offerCampaignClickthroughURL, '_system');
                        }
                    } else {
                        console.log('User dont want to go merchant`s site...');
                    }
                });
            };

            $scope.redirectToOffer = function (clickedOffer) {
                console.log("redirectToOffer: " + clickedOffer.offerCampaignClickthroughURL);
                if (clickedOffer.offerCampaignCouponCode) {
                    $scope.copyText(clickedOffer.offerCampaignCouponCode);
                    $scope.showConfirm('COUPON `' + clickedOffer.offerCampaignCouponCode + '` COPIED',
                            'Coupon code `' + clickedOffer.offerCampaignCouponCode
                            + '` copied to your clipboard. Click below to start shopping.', clickedOffer);//clickedOffer.offerCampaignClickthroughURL);
                } else {
                    $scope.showConfirm('OFFER ACTIVATED',
                            'Click below to start shopping, no coupon code required.', clickedOffer);//clickedOffer.offerCampaignClickthroughURL);
                }
            };
        });